/* @(#)93       1.2  src/gos/3d/PEX/PEXlib/extensions/lib/PEX5Ut/pexutdbint.h, pexclnts, gos410 8/11/93 17:19:09 */
/*
 * COMPONENT_NAME: pexclnts
 *
 * FUNCTIONS:
 *
 * ORIGINS: 27, 42
 *
 * (C) COPYRIGHT International Business Machines Corp. 1993
 * All Rights Reserved
 * Licensed Materials - Property of IBM
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
*/
/*
 * This is a SAMPLE program for illustration purposes only.
 * IBM makes no commitment for support of this module.
 */
/******************************************************************************/
/*  (c) Copyright Hewlett-Packard Company, 1992,  Fort Collins, Colorado      */
/*                                                                            */
/*                            All Rights Reserved                             */
/*                                                                            */
/*  Permission to use, copy, modify, and distribute this software and its     */
/*  documentation for any purpose and without fee is hereby granted provided  */
/*  that the above copyright notices appear in all copies and that both the   */
/*  copyright notices and this permission notice appear in supporting         */
/*  documentation, and that the name of Hewlett-Packard not be used in        */
/*  advertising or publicity pertaining to distribution of the software       */
/*  without specific, written prior permission.                               */
/*                                                                            */
/*  HEWLETT-PACKARD MAKES NO WARRANTY OF ANY KIND WITH REGARD TO THIS         */
/*  SOFTWARE, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/*  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  Hewlett-Packard    */
/*  shall not be liable for errors contained herein or direct, indirect,      */
/*  special, incidental or consequential damages in connection with the       */
/*  furnishing, performance or use of this software.                          */
/*                                                                            */
/******************************************************************************/

/******************************************************************************/
/*                                                                            */
/* Module:  PEXlib Double-Buffer Utilities (see file pexutdb.h for more info) */
/*                                                                            */
/* File Content:                                                              */
/*   This file contains constants, data structures and function declarations  */
/*   for internal use in the PEXlib double-buffer utilities.                  */
/*                                                                            */
/******************************************************************************/


#ifndef _PEXUTDBINT_H_ /* [ */
#define _PEXUTDBINT_H_


#ifndef NeedFunctionPrototypes
#if defined(FUNCPROTO) || defined(__STDC__) || \
    defined(__cplusplus) || defined(c_plusplus)
#define NeedFunctionPrototypes  1
#else
#define NeedFunctionPrototypes  0
#endif /* FUNCPROTO, __STDC__, __cplusplus, c_plusplus */
#endif /* NeedFunctionPrototypes */


#ifdef __cplusplus   /* do not leave open across includes */
extern "C" {         /* for C++ V2.0 */
#endif


/*
** Data structures and constants for the Multi-Buffering Extension (MBX).
** This is included here because some vendors ship the MBX library extension,
** but not the multibuf.h include file.
** This is the X11R5 version of the multibuf.h include file.
*/

/*
 * $XConsortium: multibuf.h,v 1.15 91/07/12 10:20:42 rws Exp $
 *
 * Copyright 1989 Massachusetts Institute of Technology
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of M.I.T. not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.  M.I.T. makes no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * M.I.T. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL M.I.T.
 * BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
 * OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifndef _MULTIBUF_H_ /* [ */
#define _MULTIBUF_H_

#define MULTIBUFFER_PROTOCOL_NAME "Multi-Buffering"

#define MULTIBUFFER_MAJOR_VERSION	1	/* current version numbers */
#define MULTIBUFFER_MINOR_VERSION	0

#define X_MbufGetBufferVersion		0
#define X_MbufCreateImageBuffers	1
#define X_MbufDestroyImageBuffers	2
#define X_MbufDisplayImageBuffers	3
#define X_MbufSetMBufferAttributes	4
#define X_MbufGetMBufferAttributes	5
#define X_MbufSetBufferAttributes	6
#define X_MbufGetBufferAttributes	7
#define X_MbufGetBufferInfo		8
#define X_MbufCreateStereoWindow	9

/*
 * update_action field
 */
#define MultibufferUpdateActionUndefined	0
#define MultibufferUpdateActionBackground	1
#define MultibufferUpdateActionUntouched	2
#define MultibufferUpdateActionCopied		3

/*
 * update_hint field
 */
#define MultibufferUpdateHintFrequent		0
#define MultibufferUpdateHintIntermittent	1
#define MultibufferUpdateHintStatic		2

/*
 * valuemask fields
 */
#define MultibufferWindowUpdateHint	(1L << 0)
#define MultibufferBufferEventMask	(1L << 0)

/*
 * mono vs. stereo and left vs. right
 */
#define MultibufferModeMono		0
#define MultibufferModeStereo		1
#define MultibufferSideMono		0
#define MultibufferSideLeft	  	1
#define MultibufferSideRight		2

/*
 * clobber state
 */
#define MultibufferUnclobbered		0
#define MultibufferPartiallyClobbered	1
#define MultibufferFullyClobbered	2

/*
 * event stuff
 */
#define MultibufferClobberNotifyMask	0x02000000
#define MultibufferUpdateNotifyMask	0x04000000

#define MultibufferClobberNotify	0
#define MultibufferUpdateNotify		1
#define MultibufferNumberEvents		(MultibufferUpdateNotify + 1)

#define MultibufferBadBuffer		0
#define MultibufferNumberErrors		(MultibufferBadBuffer + 1)


#ifndef _MULTIBUF_SERVER_ /* [ */
/*
 * Extra definitions that will only be needed in the client
 */
typedef XID Multibuffer;

typedef struct {
    int	type;		    /* of event */
    unsigned long serial;   /* # of last request processed by server */
    int send_event;	    /* true if this came frome a SendEvent request */
    Display *display;	    /* Display the event was read from */
    Multibuffer buffer;	    /* buffer of event */
    int	state;		    /* see Clobbered constants above */
} XmbufClobberNotifyEvent;

typedef struct {
    int	type;		    /* of event */
    unsigned long serial;   /* # of last request processed by server */
    int send_event;	    /* true if this came frome a SendEvent request */
    Display *display;	    /* Display the event was read from */
    Multibuffer buffer;	    /* buffer of event */
} XmbufUpdateNotifyEvent;


/*
 * per-window attributes that can be got
 */
typedef struct {
    int displayed_index;	/* which buffer is being displayed */
    int update_action;		/* Undefined, Background, Untouched, Copied */
    int update_hint;		/* Frequent, Intermittent, Static */
    int window_mode;		/* Mono, Stereo */
    int nbuffers;		/* Number of buffers */
    Multibuffer *buffers;	/* Buffers */
} XmbufWindowAttributes;

/*
 * per-window attributes that can be set
 */
typedef struct {
    int update_hint;		/* Frequent, Intermittent, Static */
} XmbufSetWindowAttributes;


/*
 * per-buffer attributes that can be got
 */
typedef struct {
    Window window;		/* which window this belongs to */
    unsigned long event_mask;	/* events that have been selected */
    int buffer_index;		/* which buffer is this */
    int side;			/* Mono, Left, Right */
} XmbufBufferAttributes;

/*
 * per-buffer attributes that can be set
 */
typedef struct {
    unsigned long event_mask;	/* events that have been selected */
} XmbufSetBufferAttributes;


/*
 * per-screen buffer info (there will be lists of them)
 */
typedef struct {
    VisualID visualid;		/* visual usuable at this depth */
    int max_buffers;		/* most buffers for this visual */
    int depth;			/* depth of buffers to be created */
} XmbufBufferInfo;

extern Bool XmbufQueryExtension(
#if NeedFunctionPrototypes
    Display*		/* dpy */,
    int*		/* event_base_return */,
    int*		/* error_base_return */
#endif
);

extern Status XmbufGetVersion(
#if NeedFunctionPrototypes
    Display*		/* dpy */,
    int*		/* major_version_return */,
    int*		/* minor_version_return */
#endif
);

extern int XmbufCreateBuffers(
#if NeedFunctionPrototypes
    Display*		/* dpy */,
    Window		/* w */,
    int			/* count */,
    int			/* update_action */,
    int			/* update_hint */,
    Multibuffer*	/* buffers */
#endif
);

extern void XmbufDestroyBuffers(
#if NeedFunctionPrototypes
    Display*		/* dpy */,
    Window		/* window */
#endif
);

extern void XmbufDisplayBuffers(
#if NeedFunctionPrototypes
    Display*		/* dpy */,
    int			/* count */,
    Multibuffer*	/* buffers */,
    int			/* min_delay */,
    int			/* max_delay */
#endif
);

extern Status XmbufGetWindowAttributes(
#if NeedFunctionPrototypes
    Display*			/* dpy */,
    Window			/* w */,
    XmbufWindowAttributes*	/* attr */
#endif
);

extern void XmbufChangeWindowAttributes(
#if NeedFunctionPrototypes
    Display*			/* dpy */,
    Window			/* w */,
    unsigned long		/* valuemask */,
    XmbufSetWindowAttributes*	/* attr */
#endif
);

extern Status XmbufGetBufferAttributes(
#if NeedFunctionPrototypes
    Display*			/* dpy */,
    Multibuffer			/* b */,
    XmbufBufferAttributes*	/* attr */
#endif
);

extern void XmbufChangeBufferAttributes(
#if NeedFunctionPrototypes
    Display*			/* dpy */,
    Multibuffer			/* b */,
    unsigned long		/* valuemask */,
    XmbufSetBufferAttributes*	/* attr */
#endif
);

extern Status XmbufGetScreenInfo(
#if NeedFunctionPrototypes
    Display*			/* dpy */,
    Drawable			/* d */,
    int*			/* nmono_return */,
    XmbufBufferInfo**		/* mono_info_return */,
    int*			/* nstereo_return */,
    XmbufBufferInfo**		/* stereo_info_return */
#endif
);

extern Window XmbufCreateStereoWindow(
#if NeedFunctionPrototypes
    Display*			/* dpy */,
    Window			/* parent */,
    int				/* x */,
    int				/* y */,
    unsigned int		/* width */,
    unsigned int		/* height */,
    unsigned int		/* border_width */,
    int				/* depth */,
    unsigned int		/* class */,
    Visual*			/* visual */,
    unsigned long		/* valuemask */,
    XSetWindowAttributes*	/* attr */,
    Multibuffer*		/* leftp */,
    Multibuffer*		/* rightp */
#endif
);

#endif /* _MULTIBUF_SERVER_ ] */
#endif /* _MULTIBUF_H_ ] */

/*
** Data structures and constants for HP/E&S double-buffering escapes
*/

/*
** The following is to prevent multiple inclusion of information from HP's
** vendor specific header file (PEXHPlib.h).  If other vendors also have vendor
** specific header file(s), they should define a similar symbol and also add it
** to this header file by adding to the compiler directive below, e.g.
** #if !defined (_PEXHPLIB_H_) || !defined (_SOME_OTHER_SYMBOL_)
*/
#if !defined (_PEXHPLIB_H_) /* [ */

/*
** Constants for HP and E&S double-buffering escapes
*/
#define ES_ESCAPE_DBLBUFFER             0x80040001      /* escape for db      */
#define ES_RENDERER_SINGLEBUFFER                 0      /* turn db off        */
#define ES_RENDERER_DBLBUFFER                    1      /* turn db on         */

#define ES_ESCAPE_SWAPBUFFER            0x80040002      /* escape to swap buf */

#define ES_ESCAPE_SWAPBUFFERCONTENT     0x80040003      /* escape to inquire  */
#define ES_DB_SWAP_CONTENT_UNDEFINED             0      /* what the content   */
#define ES_DB_SWAP_CONTENT_CLEAR_TO_BACKGROUND   1      /* of the back buffer */
#define ES_DB_SWAP_CONTENT_UNCHANGED             2      /* will be after a    */
#define ES_DB_SWAP_CONTENT_FRONTBUFFER           3      /* swap is done       */

#define HP_ESCAPE_DFRONT                0x80070001      /* escape render cntl */
#define HP_RENDER_TO_BACK_BUFFER                 0      /* render to back     */
#define HP_RENDER_TO_FRONT_BUFFER                1      /* render to front    */

/*
** Constants for enumerated type descriptors returned from PEXGetEnumTypeInfo
*/
#define ES_ESCAPE_ET_DBLBUFFER          0x8401
#define ES_ESCAPE_ET_SWAPBUFFER         0x8402
#define ES_ESCAPE_ET_SWAPBUFFERCONTENT  0x8403
#define HP_ESCAPE_ET_DFRONT             0x8701

#define ES_ESCAPE_ETM_DBLBUFFER         "ES_ESCAPE_DBLBUFFER"
#define ES_ESCAPE_ETM_SWAPBUFFER        "ES_ESCAPE_SWAPBUFFER"
#define ES_ESCAPE_ETM_SWAPBUFFERCONTENT "ES_ESCAPE_SWAPBUFFERCONTENT"
#define HP_ESCAPE_ETM_DFRONT            "HP_ESCAPE_DFRONT"

/*
** Data structures for HP and E&S double-buffering.
** The PEXEscape function is defined in PEXlib.h.
** These define the data argument for PEXEscape.
*/
typedef struct {        /* Data for ES_ESCAPE_DBLBUFFER in PEXEscape function */
   Drawable             drawable;
   unsigned long        bufferMode;
} esEscapeDblBuffer;

typedef struct {        /* Data for ES_ESCAPE_SWAPBUFFER in PEXEscape function*/
   Drawable             drawable;
} esEscapeSwapBuffer;

typedef struct {/* Data for ES_ESCAPE_SWAPBUFFERCONTENT in PEXEscapeWithReply */
   Drawable             drawable;
} esEscapeSwapBufferContent;

typedef struct {/* Return from PEXEscapeWithReply, ES_ESCAPE_SWAPBUFFERCONTENT*/
   unsigned long        content;
} esEscapeSwapBufferContentReply;

typedef struct {        /* Data for HP_ESCAPE_DFRONT in PEXEscape function    */
   Drawable             drawable;
   int                  render_to_front_buffer;
} hpEscapeSetRenderingBuffer;

#endif /* ] */

/*
** Aliases for DFRONT constants defined in order to match data structure name
*/
#define HP_ESCAPE_SETRENDERINGBUFFER            0x80070001
#define HP_ESCAPE_ET_SETRENDERINGBUFFER         0x8701
#define HP_ESCAPE_ETM_SETRENDERINGBUFFER        "HP_ESCAPE_DFRONT"


/*
** constants for dbtype variable in PEXUtDBData
*/
#define PEXUTDBMBX      0
#define PEXUTDBESC      1
#define PEXUTDBPIX      2

/*
** Global internal data
*/
typedef struct pexutdbdata {
    Window              window;         /* window id - also search key        */
    Display             *display;       /* display ptr - secondary search key */
    struct pexutdbdata  *next;          /* ptr to next node in the data list  */
    int                 db_type;        /* indicates db mechanism used        */
    int                 front_supported;/* indicates support of render front  */
    int                 render_to_front;/* flag indicating front or back      */
    int                 db_x;           /* indicates double-buffer X rendering*/
    Multibuffer         back_buffer;    /* current back buffer, if MBX        */
    Multibuffer         buffers[2];     /* buffer identifiers, if using MBX   */
    PEXRenderer         renderer;       /* renderer id, used for clearing     */
    int                 clear_renderer; /* flag indicating whether to clear   */
    Pixmap              pixmap;         /* pixmap identifier, if using pixmap */
    GC                  gc;             /* gc for clearing pixmap             */
    int                 width;          /* window width                       */
    int                 height;         /* window height                      */
    int                 depth;          /* window depth                       */
} PEXUtDBData;


/******************************************************************************/
/*                                                                            */
/* Internal Functions Description:                                            */
/*   This set of functions provides a simple interface for managing global    */
/*   data in the PEXlib double-buffer utilities.                              */
/*                                                                            */
/* Internal Functions:                                                        */
/*   lookup_node  - lookup the data node for the specified window             */
/*   add_node     - add a new data node for the specified window              */
/*   delete_node  - delete the data node for the specified window             */
/*                                                                            */
/******************************************************************************/

/*
** function declarations
*/

/******************************************************************************/
/*                                                                            */
/* Function:                                                                  */
/*   lookup_node    - lookup the data node for the specified window           */
/*                                                                            */
/* Returns:                                                                   */
/*   PEXUtDBData *  - a pointer to the data node                              */
/*                                                                            */
/* Arguments:                                                                 */
/*   win            - window id search key                                    */
/*   dpy            - display ptr secondary search key                        */
/*                                                                            */
/******************************************************************************/
extern PEXUtDBData *lookup_node(
#if NeedFunctionPrototypes
    Window              /* win */,
    Display *           /* dpy */
#endif
);

/******************************************************************************/
/*                                                                            */
/* Function:                                                                  */
/*   add_node       - add a new data node for the specified window            */
/*                                                                            */
/* Returns:                                                                   */
/*   PEXUtDBData *  - a pointer to the new data node                          */
/*                                                                            */
/* Arguments:                                                                 */
/*   win            - window id search key                                    */
/*   dpy            - display ptr secondary search key                        */
/*                                                                            */
/******************************************************************************/
extern PEXUtDBData *add_node(
#if NeedFunctionPrototypes
    Window              /* win */,
    Display *           /* dpy */
#endif
);

/******************************************************************************/
/*                                                                            */
/* Function:                                                                  */
/*   delete_node    - delete the data node for the specified window           */
/*                                                                            */
/* Returns:                                                                   */
/*   void           - no return value                                         */
/*                                                                            */
/* Arguments:                                                                 */
/*   win            - window id search key                                    */
/*   dpy            - display ptr secondary search key                        */
/*                                                                            */
/******************************************************************************/
extern void delete_node(
#if NeedFunctionPrototypes
    Window              /* win */,
    Display *           /* dpy */
#endif
);


/*
** macro definition
*/

#define LOOKUP_NODE(p,w,d)                                                     \
    if ( ( pexutdb_last != (PEXUtDBData *)NULL ) &&                            \
         ( ( pexutdb_last->window == w ) && ( pexutdb_last->display == d ) ) ) \
        p = pexutdb_last;                                                      \
    else {                                                                     \
        p = lookup_node( w, d );                                               \
        pexutdb_last = p;                                                      \
    }


#ifdef __cplusplus
}                    /* for C++ V2.0 */
#endif


#endif /* _PEXUTDBINT_H_ ] */
